﻿using System.Linq.Expressions;

namespace TestProject;

/// <summary>
/// 프로그램
/// </summary>
class Program
{
    //////////////////////////////////////////////////////////////////////////////////////////////////// Method
    ////////////////////////////////////////////////////////////////////////////////////////// Static
    //////////////////////////////////////////////////////////////////////////////// Private

    #region 속성명 구하기 - GetPropertyName<T>(expression)

    /// <summary>
    /// 속성명 구하기
    /// </summary>
    /// <typeparam name="T">속성 타입</typeparam>
    /// <param name="expression">수식</param>
    /// <returns>속성명</returns>
    private static string GetPropertyName<T>(Expression<Func<T>> expression)
    {
        MemberExpression memberExpression = expression.Body as MemberExpression;

        if(memberExpression == null)
        {
            throw new ArgumentException("You must pass a lambda of the form : '() => Class.Property' or '() => object.Property'");
        }

        return memberExpression.Member.Name;
    }

    #endregion
    #region 프로그램 시작하기 - Main()

    /// <summary>
    /// 프로그램 시작하기
    /// </summary>
    private static void Main()
    {
        Student student = new Student { ID = 1, Name = "홍길동" };

        string name = GetPropertyName(() => student.Name);

        Console.WriteLine(name);
    }

    #endregion
}